aboutsummaryrefslogtreecommitdiff
diff options
context:
space:
mode:
authorMike Frysinger <vapier@gentoo.org>2008-05-31 14:33:46 -0400
committerMike Frysinger <vapier@gentoo.org>2008-05-31 14:33:46 -0400
commit441e82c9832e2d65fc2db324872928471307dbc4 (patch)
tree7eb0e2d5c922e3c3c00b63fed2e20150e53c9848
downloadrpm2targz-441e82c9832e2d65fc2db324872928471307dbc4.tar.gz
rpm2targz-441e82c9832e2d65fc2db324872928471307dbc4.tar.bz2
rpm2targz-441e82c9832e2d65fc2db324872928471307dbc4.zip
import rpm2targz-9.0 unmodifiedv9.0
Signed-off-by: Mike Frysinger <vapier@gentoo.org>
-rwxr-xr-xrpm2targz97
-rw-r--r--rpm2targz.README16
-rw-r--r--rpmoffset.c23
3 files changed, 136 insertions, 0 deletions
diff --git a/rpm2targz b/rpm2targz
new file mode 100755
index 0000000..0ab74e4
--- /dev/null
+++ b/rpm2targz
@@ -0,0 +1,97 @@
+#!/bin/sh
+# Copyright 1997, 1998 Patrick Volkerding, Moorhead, MN USA
+# Copyright 2002 Slackware Linux, Inc., Concord, CA USA
+# All rights reserved.
+#
+# Redistribution and use of this script, with or without modification, is
+# permitted provided that the following conditions are met:
+#
+# 1. Redistributions of this script must retain the above copyright
+# notice, this list of conditions and the following disclaimer.
+#
+# THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR IMPLIED
+# WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
+# MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO
+# EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
+# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
+# PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS;
+# OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
+# WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR
+# OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF
+# ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+#
+
+if [ "$TMPDIR" = "" ]; then
+ TMPDIR=/tmp
+fi
+# If mcookie is available, use it for better /tmp security.
+if [ -x `which mcookie` ]; then
+ COOKIE=`mcookie`
+else
+ COOKIE=$$
+fi
+if [ "$1" = "" ]; then
+ echo "$0: Converts RPM format to standard GNU tar + GNU zip format."
+ echo " (view converted packages with \"less\", install and remove"
+ echo " with \"installpkg\", \"removepkg\", \"pkgtool\", or manually"
+ echo " with \"tar\")"
+ echo
+ echo "Usage: $0 <file.rpm>"
+ if [ "`basename $0`" = "rpm2tgz" ]; then
+ echo " (Outputs \"file.tgz\")"
+ else
+ echo " (Outputs \"file.tar.gz\")"
+ fi
+ exit 1;
+fi
+for i in $* ; do
+ if [ ! "$1" = "$*" ]; then
+ echo -n "Processing file: $i"
+ fi
+ rm -rf $TMPDIR/rpm2targz$COOKIE # clear the way, just in case of mischief
+ mkdir $TMPDIR/rpm2targz$COOKIE
+
+ # Determine if this is a source or binary RPM.
+ # If we have getrpmtype, use that. Otherwise, try "file".
+ if which getrpmtype 1> /dev/null 2> /dev/null; then
+ if getrpmtype -n $i | grep source 1> /dev/null 2> /dev/null ; then
+ isSource=1
+ else
+ isSource=0
+ fi
+ else # use file. This works fine on Slackware, and is the default.
+ if file $i | grep RPM | grep " src " 1> /dev/null 2> /dev/null ; then
+ isSource=1
+ else
+ isSource=0
+ fi
+ fi
+
+ ofn=$TMPDIR/rpm2targz$COOKIE/`basename $i .rpm`.cpio
+ if which rpm2cpio 1> /dev/null 2> /dev/null ; then
+ rpm2cpio $i > $ofn 2> /dev/null
+ if [ ! $? = 0 ]; then
+ echo "... rpm2cpio failed. (maybe $i is not an RPM?)"
+ ( cd $TMPDIR ; rm -rf rpm2targz$COOKIE )
+ continue
+ fi
+ else # less reliable than rpm2cpio...
+ dd ibs=`rpmoffset < $i` skip=1 if=$i 2> /dev/null | gzip -dc > $ofn
+ fi
+ DEST=$TMPDIR/rpm2targz$COOKIE
+ if [ "$isSource" = "1" ]; then
+ DEST=$DEST/$(basename $(basename $i .rpm) .src)
+ fi
+ mkdir -p $DEST
+ ( cd $DEST
+ cpio --extract --preserve-modification-time --make-directories < $ofn 1> /dev/null 2> /dev/null
+ rm -f $ofn
+ find . -type d -perm 700 -exec chmod 755 {} \; )
+ ( cd $TMPDIR/rpm2targz$COOKIE ; tar cf - . ) > `basename $i .rpm`.tar
+ gzip -9 `basename $i .rpm`.tar
+ if [ "`basename $0`" = "rpm2tgz" ]; then
+ mv `basename $i .rpm`.tar.gz `basename $i .rpm`.tgz
+ fi
+ ( cd $TMPDIR ; rm -rf rpm2targz$COOKIE )
+ echo
+done
diff --git a/rpm2targz.README b/rpm2targz.README
new file mode 100644
index 0000000..9936f05
--- /dev/null
+++ b/rpm2targz.README
@@ -0,0 +1,16 @@
+
+This package contains 'rpm2targz', a simple utility to convert Red Hat-style
+RPM packages into standard tar.gz archives. Converted binary packages can then
+be installed/removed using the 'installpkg/removepkg' commands, or 'pkgtool'.
+
+It's advisable to at least examine the converted package with 'less' to make
+sure it won't do anything too crazy to your system.
+
+By default, rpm2targz will attempt to use "file" to detect source RPMS, and will
+put the contents into a subdirectory in the resulting package. This may not be
+portable to other operating systems -- if you're trying to run rpm2targz on an
+OS that doesn't have a file that knows RPM types, and you care about this source
+RPM feature, you can compile and install David Cantrell's standalone getrpmtype
+utility. The getrpmtype.tar.gz source archive can be found in Slackware's
+source tree in source/a/bin/.
+
diff --git a/rpmoffset.c b/rpmoffset.c
new file mode 100644
index 0000000..ac5984c
--- /dev/null
+++ b/rpmoffset.c
@@ -0,0 +1,23 @@
+
+/* Find how deeply inside an .RPM the real data is */
+/* kept, and report the offset in bytes */
+
+/* Wouldn't it be a lot more sane if we could just untar these things? */
+
+#include <stdlib.h>
+
+/* These offsets keep getting bigger, so we're going to just bite a 2MB */
+/* chunk of RAM right away so that we have enough. Yeah, horrible */
+/* quick and dirty implementation, but hey -- it gets the job done. */
+
+#define RPMBUFSIZ 2097152
+
+main()
+{
+ char *buff = malloc(RPMBUFSIZ),*eb,*p;
+ for (p = buff, eb = buff + read(0,buff,RPMBUFSIZ); p < eb; p++)
+ if (*p == '\037' && p[1] == '\213' && p[2] == '\010')
+ printf("%d\n",p - buff),
+ exit(0);
+ exit(1);
+}